<?php

/**
 * deduccion_novedad actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage deduccion_novedad
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class deduccion_novedadActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
//        if (isset($request['_startRow'])) {
//            $rowStart = $request['_startRow'];
//        } else {
//            $rowStart = 0;
//        }
//
//        if (isset($request['_endRow'])) {
//            $rowEnd = $request['_endRow'];
//        } else {
//            $rowEnd = 75;
//        }
        //ordenar consulta
        if (isset($request['_sortBy'])) {
            //   $sortBy = " Order by " . $request['_sortBy'];
        } else {
            //    $sortBy = 'order by CODIGO ';
        }

        /*
         * Manejo de errores
         */
        try {


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            /*
             * Variables obligatorias
             */
            //$punto_venta_log = $request['punto_venta_log'];
            $id_contratista = $request['id_contratista'];
            $id_contrato = $request['id_contrato'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            //$fecha=date_format($fecha,'Y-m-d');
            $valor = $request['valor'];
            $valor_diario = $valor / 30;


            /**
             * Buscamos si aplica deduccion por novedades
             */
            $sql = <<<EOD
SELECT id_novedad_suspension,
  fecha_ini,
  fecha_fin,
  (case when fecha_fin>to_date('$fecha_fin','YYYY-MM-DD') then to_date('$fecha_fin','YYYY-MM-DD') else fecha_fin end -
  case when fecha_ini<to_date('$fecha_ini','YYYY-MM-DD') then to_date('$fecha_ini','YYYY-MM-DD') else fecha_ini end)+1
  as dias_deduccion,
  ROUND(((case when fecha_fin>to_date('$fecha_fin','YYYY-MM-DD') then to_date('$fecha_fin','YYYY-MM-DD') else fecha_fin end -
  case when fecha_ini<to_date('$fecha_ini','YYYY-MM-DD') then to_date('$fecha_ini','YYYY-MM-DD') else fecha_ini end )+1)
  * $valor_diario)
  as valor_deduccion
FROM rvc_novedad_suspension
WHERE id_contratista = $id_contratista 
and id_contrato = $id_contrato 
and (fecha_ini<=to_date('$fecha_fin','YYYY-MM-DD') and fecha_fin>=to_date('$fecha_ini','YYYY-MM-DD'))
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            if (count($resultado) > 0) {

                $this->totalRows = count($resultado);
                $this->startRow = 0;
                $this->endRow = 0 + count($resultado);
                $this->list_data = $resultado;
                $this->logMessage("[producto_desc] Consulta de producto exitosa.");
            } else {

                $this->status = 0;
                $this->list_data = array();
                $this->logMessage("No hay Deducciones que aplicar.");
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    // public function executeIndex(sfWebRequest $request)
    //{
    //  $this->forward('default', 'module');
    //}
}
